= nng_pair_open(3)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_pair_open - create pair socket

== SYNOPSIS

.Version 0
[source,c]
----
#include <nng/protocol/pair0/pair.h>

int nng_pair0_open(nng_socket *s);

int nng_pair0_open_raw(nng_socket *s);
----

.Version 1
[source,c]
----
#include <nng/protocol/pair1/pair.h>

int nng_pair1_open(nng_socket *s);

int nng_pair1_open_raw(nng_socket *s);

int nng_pair1_open_poly(nng_socktet *s);
----

== DESCRIPTION

The `nng_pair0_open()` and `nng_pair1_open()` functions
create a xref:nng_pair.7.adoc[_pair_] version 0 or version 1
xref:nng_socket.5.adoc[socket] and return it at the location pointed to by _s_.

The `nng_pair0_open_raw()` and `nng_pair1_open_raw()` functions
create a xref:nng_pair.7.adoc[_pair_] version 0 or version 1
xref:nng_socket.5.adoc[socket] in
xref:nng.7.adoc#raw_mode[raw] mode and return it at the location pointed to by _s_.

The `nng_pair1_open_poly()` function opens a pair version 1 socket in
polyamorous mode.

NOTE: Polyamorous mode is deprecated and should not be used in new applications.
The `nng_pair1_open_poly()` function will likely be removed in a future release.

== RETURN VALUES

These functions returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient memory is available.
`NNG_ENOTSUP`:: The protocol is not supported.

== SEE ALSO

[.text-left]
xref:nng_socket.5.adoc[nng_socket(5)],
xref:nng_pair.7.adoc[nng_pair(7)],
xref:nng.7.adoc[nng(7)]
